package cn.com.infosec.asn1.sec;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1Object;
import cn.com.infosec.asn1.ASN1OctetString;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1TaggedObject;
import cn.com.infosec.asn1.DERBitString;
import cn.com.infosec.asn1.DEREncodable;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DEROctetString;
import cn.com.infosec.asn1.DERSequence;
import java.math.BigInteger;
import java.util.Enumeration;

public class ECPrivateKeyStructure extends ASN1Encodable {
   private ASN1Sequence seq;

   public ECPrivateKeyStructure(ASN1Sequence seq) {
      this.seq = seq;
   }

   public ECPrivateKeyStructure(BigInteger key) {
      byte[] var2;
      byte[] key1;
      if ((key1 = key.toByteArray())[0] == 0) {
         byte[] var10000 = key1;
         int key2;
         var2 = new byte[key2 = key1.length - 1];
         System.arraycopy(var10000, 1, var2, 0, key2);
      } else {
         var2 = key1;
      }

      ECPrivateKeyStructure var9 = this;
      ASN1EncodableVector var3;
      ASN1EncodableVector var10001 = var3 = new ASN1EncodableVector;
      var10001.<init>();
      DERInteger key3;
      key3 = new DERInteger.<init>(1);
      var10001.add(key3);
      DEROctetString key4;
      key4 = new DEROctetString.<init>(var2);
      var10001.add(key4);
      DERSequence key5;
      key5 = new DERSequence.<init>(var3);
      var9.seq = key5;
   }

   private ASN1Object getObjectInTag(int tagNo) {
      Enumeration var3 = this.seq.getObjects();

      DEREncodable var2;
      ASN1TaggedObject var4;
      do {
         if (!var3.hasMoreElements()) {
            return null;
         }
      } while(!((var2 = (DEREncodable)var3.nextElement()) instanceof ASN1TaggedObject) || (var4 = (ASN1TaggedObject)var2).getTagNo() != tagNo);

      return (ASN1Object)var4.getObject().getDERObject();
   }

   public BigInteger getKey() {
      ASN1OctetString var1 = (ASN1OctetString)this.seq.getObjectAt(1);
      return new BigInteger(1, var1.getOctets());
   }

   public DERBitString getPublicKey() {
      return (DERBitString)this.getObjectInTag(1);
   }

   public ASN1Object getParameters() {
      return this.getObjectInTag(0);
   }

   public DERObject toASN1Object() {
      return this.seq;
   }
}
